package com.ejie.ab39a.dao;

import com.ejie.ab39a.model.Elemento;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JQGridManager;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.TableRowDto;
import com.gfi.constants.Constants;
import com.gfi.utils.UtilSQL;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;
import javax.sql.DataSource;
import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab39a.model.Acciones;

/**
 * AccionesDaoImpl.
 * 
 *  
 */

@Repository
@Transactional
public class AccionesDaoImpl implements AccionesDao {

	private static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDACCION", "IDELEMENTO", "ORDEN", "NOMBREEUS",
			"NOMBRECAS" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<Acciones> rwMap = new RowMapper<Acciones>() {
		@Override
		public Acciones mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Acciones(resultSet.getInt("IDACCION"), resultSet.getLong("ORDEN"),
					resultSet.getString("NOMBREEUS"), resultSet.getString("NOMBRECAS"),
					new Elemento(resultSet.getLong("ElementoIDELEMENTO"), resultSet.getLong("ElementoORDEN"),
							resultSet.getLong("ElementoNIVEL"), resultSet.getLong("ElementoPONDERACION"),
							resultSet.getInt("ElementoTIENEELEBI"), resultSet.getString("ElementoNOMBRE"),
							resultSet.getString("ElementoNOMBRECAS"), resultSet.getLong("ElementoIDEJE"),
							resultSet.getLong("ElementoIDELEMENTOPADRE"), resultSet.getString("ElementoHELBURU"),
							resultSet.getString("ElementoHELBURUCAS")));
		}
	};

	private RowMapper<Acciones> rwMapPK = new RowMapper<Acciones>() {
		@Override
		public Acciones mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Acciones(resultSet.getInt("IDACCION"));
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 * @return Acciones
	 */
	@Override
	public Acciones add(Acciones acciones) {
		StringBuilder query = new StringBuilder(
				"INSERT INTO ACCIONES (IDACCION, IDELEMENTO, ORDEN, NOMBREEUS, NOMBRECAS) VALUES (?,?,?,?,?)");
		Object getElementoIdElementoAux = null;
		if (acciones.getElemento() != null && acciones.getElemento().getIdElemento() != null) {
			getElementoIdElementoAux = acciones.getElemento().getIdElemento();
		}
		this.jdbcTemplate.update(query.toString(), acciones.getIdaccion(), getElementoIdElementoAux,
				acciones.getOrden(), acciones.getNombreeus(), acciones.getNombrecas());
		return acciones;
	}

	/**
	 * Updates a single row in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 * @return Acciones
	 */
	@Override
	public Acciones update(Acciones acciones) {
		StringBuilder query = new StringBuilder("UPDATE ACCIONES SET IDELEMENTO=?, ORDEN=?, NOMBREEUS=?, NOMBRECAS=?");
		query.append(" WHERE IDACCION=?");
		Object getElementoIdElementoAux = null;
		if (acciones.getElemento() != null && acciones.getElemento().getIdElemento() != null) {
			getElementoIdElementoAux = acciones.getElemento().getIdElemento();
		}
		this.jdbcTemplate.update(query.toString(), getElementoIdElementoAux, acciones.getOrden(),
				acciones.getNombreeus(), acciones.getNombrecas(), acciones.getIdaccion());
		return acciones;
	}

	/**
	 * Finds a single row in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 * @return Acciones
	 */
	@Override
	@Transactional(readOnly = true)
	public Acciones find(Acciones acciones) {
		// SELECT - FROM
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true));
		// WHERE
		query.append(" WHERE t1.IDACCION = ?   AND t1.IDELEMENTO= t2.ID_ELEMENTO(+)");

		List<Acciones> accionesList = this.jdbcTemplate.query(query.toString(), this.rwMap, acciones.getIdaccion());
		return DataAccessUtils.uniqueResult(accionesList);
	}

	/**
	 * Removes a single row in the Acciones table.
	 *
	 * @param acciones
	 *            Acciones
	 */
	@Override
	public void remove(Acciones acciones) {
		String query = "DELETE FROM ACCIONES WHERE IDACCION=?";
		this.jdbcTemplate.update(query, acciones.getIdaccion());
	}

	/**
	 * Finds a list of rows in the Acciones table.
	 * 
	 * @param acciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Acciones>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<Acciones> findAll(Acciones acciones, JQGridRequestDto jqGridRequestDto) {
		// SELECT - FROM
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true));

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(acciones);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.IDELEMENTO= t2.ID_ELEMENTO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (jqGridRequestDto != null) {
			query = JQGridManager.getPaginationQuery(jqGridRequestDto, query, AccionesDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the Acciones table using like.
	 * 
	 * @param acciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Acciones>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<Acciones> findAllLike(Acciones acciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		// SELECT - FROM
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true));

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(acciones, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.IDELEMENTO= t2.ID_ELEMENTO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (jqGridRequestDto != null) {
			query = JQGridManager.getPaginationQuery(jqGridRequestDto, query, AccionesDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the Acciones table using like.
	 * 
	 * @param acciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Acciones>
	 */
	@Override
	@Transactional(readOnly = true)
	public List<Acciones> buscarTablaAccionesPg(Acciones acciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		// SELECT - FROM
		StringBuilder query = new StringBuilder(
				"SELECT t1.IDACCION IDACCION,  t1.ORDEN ORDEN,  t1.NOMBREEUS NOMBREEUS,  t1.NOMBRECAS NOMBRECAS,  t2.ID_ELEMENTO ELEMENTOIDELEMENTO,");
		query.append(
				" t2.ORDEN ELEMENTOORDEN,  t2.NIVEL ELEMENTONIVEL,  t2.PONDERACION ELEMENTOPONDERACION,  t2.TIENEELEBI ELEMENTOTIENEELEBI,  t2.NOMBRE ELEMENTONOMBRE,");
		query.append(
				" t2.NOMBRECAS ELEMENTONOMBRECAS,  t2.ID_EJE ELEMENTOIDEJE,  t2.ID_ELEMENTOPADRE ELEMENTOIDELEMENTOPADRE,  t2.HELBURU ELEMENTOHELBURU,  t2.HELBURUCAS ELEMENTOHELBURUCAS");
		query.append(
				" FROM ACCIONES t1,  ELEMENTO t2,  AB3910T00 WHERE t1.IDELEMENTO      = t2.ID_ELEMENTO AND AB3910T00.IDELEMENTO = t2.ID_ELEMENTO");
		query.append(" AND AB3910T00.CODELEMPG = " + acciones.getElemento().getIdElemento());
		query.append(" AND t1.IDACCION not in(SELECT ACCIONES_PG.IDACCION FROM ACCIONES_PG WHERE CODELEMPG ="
				+ acciones.getElemento().getIdElemento() + " AND IDACCION IS NOT NULL )");

		if (jqGridRequestDto != null) {
			query = JQGridManager.getPaginationQuery(jqGridRequestDto, query, AccionesDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap);
	}

	/**
	 * Counts rows in the Acciones table using like.
	 * 
	 * @param acciones
	 *            Acciones
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long buscarTablaAccionesPgCount(Acciones acciones, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM (");
		query.append(
				"SELECT t1.IDACCION IDACCION,  t1.ORDEN ORDEN,  t1.NOMBREEUS NOMBREEUS,  t1.NOMBRECAS NOMBRECAS,  t2.ID_ELEMENTO ELEMENTOIDELEMENTO,");
		query.append(
				" t2.ORDEN ELEMENTOORDEN,  t2.NIVEL ELEMENTONIVEL,  t2.PONDERACION ELEMENTOPONDERACION,  t2.TIENEELEBI ELEMENTOTIENEELEBI,  t2.NOMBRE ELEMENTONOMBRE,");
		query.append(
				" t2.NOMBRECAS ELEMENTONOMBRECAS,  t2.ID_EJE ELEMENTOIDEJE,  t2.ID_ELEMENTOPADRE ELEMENTOIDELEMENTOPADRE,  t2.HELBURU ELEMENTOHELBURU,  t2.HELBURUCAS ELEMENTOHELBURUCAS");
		query.append(
				" FROM ACCIONES t1,  ELEMENTO t2,  AB3910T00 WHERE t1.IDELEMENTO      = t2.ID_ELEMENTO AND AB3910T00.IDELEMENTO = t2.ID_ELEMENTO");
		query.append(" AND AB3910T00.CODELEMPG = " + acciones.getElemento().getIdElemento());
		query.append(" AND t1.IDACCION not in(SELECT ACCIONES_PG.CODACCIONPG FROM ACCIONES_PG WHERE CODELEMPG ="
				+ acciones.getElemento().getIdElemento() + "))");

		return this.jdbcTemplate.queryForObject(query.toString(), Long.class);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the Acciones table.
	 * 
	 * @param acciones
	 *            Acciones
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long findAllCount(Acciones acciones) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM ACCIONES t1 , ELEMENTO t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(acciones);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.IDELEMENTO= t2.ID_ELEMENTO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the Acciones table using like.
	 * 
	 * @param acciones
	 *            Acciones
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Override
	@Transactional(readOnly = true)
	public Long findAllLikeCount(Acciones acciones, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM ACCIONES t1 ,ELEMENTO t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(acciones, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.IDELEMENTO= t2.ID_ELEMENTO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of Acciones selected for rup_table
	 * 
	 * @param acciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Acciones>>
	 */
	@Override
	public List<TableRowDto<Acciones>> reorderSelection(Acciones acciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith) {
		// SELECT - FROM
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true));

		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(acciones, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.IDELEMENTO= t2.ID_ELEMENTO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings(value = "unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = JQGridManager.getReorderQuery(query, jqGridRequestDto, Acciones.class,
				filterParamList, "IDACCION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<Acciones>(this.rwMapPK, jqGridRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 * 
	 * @param filterAcciones
	 *            Acciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(Acciones filterAcciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith) {
		// SELECT - FROM
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(this.getSelectFromQuery(true));

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterAcciones, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.IDELEMENTO= t2.ID_ELEMENTO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings(value = "unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = JQGridManager.getRemoveMultipleQuery(jqGridRequestDto, Acciones.class,
				query, params, "IDACCION");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Devuelve la Select con todos los campos. Incluye el From si se indica.
	 * 
	 * @param includeFrom
	 *            boolean
	 * @return String
	 */
	private String getSelectFromQuery(boolean includeFrom) {
		StringBuilder query = new StringBuilder(
				"SELECT t1.IDACCION IDACCION, t1.ORDEN ORDEN, t1.NOMBRE NOMBREEUS, t1.NOMBRECAS NOMBRECAS, t2.ID_ELEMENTO ELEMENTOIDELEMENTO, t2.ORDEN ELEMENTOORDEN, t2.NIVEL ELEMENTONIVEL, t2.PONDERACION ELEMENTOPONDERACION, t2.TIENEELEBI ELEMENTOTIENEELEBI, t2.NOMBRE ELEMENTONOMBRE, t2.NOMBRECAS ELEMENTONOMBRECAS, t2.ID_EJE ELEMENTOIDEJE, t2.ID_ELEMENTOPADRE ELEMENTOIDELEMENTOPADRE, t2.HELBURU ELEMENTOHELBURU, t2.HELBURUCAS ELEMENTOHELBURUCAS ");
		if (includeFrom) {
			query.append(" FROM ACCIONES t1 , ELEMENTO t2 ");
		}
		return query.toString();
	}

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Acciones entity
	 * 
	 * @param acciones
	 *            Acciones Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(Acciones acciones) {

		StringBuilder where = new StringBuilder(Constants.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (acciones != null) {
			if (acciones.getIdaccion() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.IDACCION", acciones.getIdaccion());
			}
			if (acciones.getElemento() != null) {
				if (acciones.getElemento().getIdElemento() != null) {
					UtilSQL.createFilterSQL(where, params, "t2.ID_ELEMENTO", acciones.getElemento().getIdElemento());
				}
				if (acciones.getElemento().getOrden() != null) {
					UtilSQL.createFilterSQL(where, params, "t2.ORDEN", acciones.getElemento().getOrden());
				}
				if (acciones.getElemento().getNivel() != null) {
					UtilSQL.createFilterSQL(where, params, "t2.NIVEL", acciones.getElemento().getNivel());
				}
				if (acciones.getElemento().getPonderacion() != null) {
					UtilSQL.createFilterSQL(where, params, "t2.PONDERACION", acciones.getElemento().getPonderacion());
				}
				if (acciones.getElemento().getTieneelebi() != null) {
					UtilSQL.createFilterSQL(where, params, "t2.TIENEELEBI", acciones.getElemento().getTieneelebi());
				}
				if (acciones.getElemento().getNombre() != null) {
					UtilSQL.createFilterSQL(where, params, "t2.NOMBRE", acciones.getElemento().getNombre());
				}
				if (acciones.getElemento().getNombrecas() != null) {
					UtilSQL.createFilterSQL(where, params, "t2.NOMBRECAS", acciones.getElemento().getNombrecas());
				}
				if (acciones.getElemento().getIdEje() != null) {
					UtilSQL.createFilterSQL(where, params, "t2.ID_EJE", acciones.getElemento().getIdEje());
				}
				if (acciones.getElemento().getIdElementopadre() != null) {
					UtilSQL.createFilterSQL(where, params, "t2.ID_ELEMENTOPADRE",
							acciones.getElemento().getIdElementopadre());
				}
				if (acciones.getElemento().getHelburu() != null) {
					UtilSQL.createFilterSQL(where, params, "t2.HELBURU", acciones.getElemento().getHelburu());
				}
				if (acciones.getElemento().getHelburucas() != null) {
					UtilSQL.createFilterSQL(where, params, "t2.HELBURUCAS", acciones.getElemento().getHelburucas());
				}
			}
			if (acciones.getOrden() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.ORDEN", acciones.getOrden());
			}
			if (acciones.getNombreeus() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.NOMBRE", acciones.getNombreeus());
			}
			if (acciones.getNombrecas() != null) {
				UtilSQL.createFilterSQL(where, params, "t1.NOMBRECAS", acciones.getNombrecas());
			}
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Acciones entity
	 * 
	 * @param acciones
	 *            Acciones Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	private Map<String, Object> getWhereLikeMap(Acciones acciones, Boolean startsWith) {

		StringBuilder where = new StringBuilder(Constants.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (acciones != null) {
			if (acciones.getIdaccion() != null) {
				UtilSQL.createFilterLikeSQL(where, params, "t1.IDACCION", acciones.getIdaccion(), startsWith);
			}
			if (acciones.getElemento() != null) {
				if (acciones.getElemento().getIdElemento() != null) {
					UtilSQL.createFilterLikeSQL(where, params, "t2.ID_ELEMENTO", acciones.getElemento().getIdElemento(),
							startsWith);
				}
				if (acciones.getElemento().getOrden() != null) {
					UtilSQL.createFilterLikeSQL(where, params, "t2.ORDEN", acciones.getElemento().getOrden(),
							startsWith);
				}
				if (acciones.getElemento().getNivel() != null) {
					UtilSQL.createFilterLikeSQL(where, params, "t2.NIVEL", acciones.getElemento().getNivel(),
							startsWith);
				}
				if (acciones.getElemento().getPonderacion() != null) {
					UtilSQL.createFilterLikeSQL(where, params, "t2.PONDERACION",
							acciones.getElemento().getPonderacion(), startsWith);
				}
				if (acciones.getElemento().getTieneelebi() != null) {
					UtilSQL.createFilterLikeSQL(where, params, "t2.TIENEELEBI", acciones.getElemento().getTieneelebi(),
							startsWith);
				}
				if (acciones.getElemento().getNombre() != null) {
					UtilSQL.createFilterLikeSQL(where, params, "t2.NOMBRE", acciones.getElemento().getNombre(),
							startsWith);
				}
				if (acciones.getElemento().getNombrecas() != null) {
					UtilSQL.createFilterLikeSQL(where, params, "t2.NOMBRECAS", acciones.getElemento().getNombrecas(),
							startsWith);
				}
				if (acciones.getElemento().getIdEje() != null) {
					UtilSQL.createFilterLikeSQL(where, params, "t2.ID_EJE", acciones.getElemento().getIdEje(),
							startsWith);
				}
				if (acciones.getElemento().getIdElementopadre() != null) {
					UtilSQL.createFilterLikeSQL(where, params, "t2.ID_ELEMENTOPADRE",
							acciones.getElemento().getIdElementopadre(), startsWith);
				}
				if (acciones.getElemento().getHelburu() != null) {
					UtilSQL.createFilterLikeSQL(where, params, "t2.HELBURU", acciones.getElemento().getHelburu(),
							startsWith);
				}
				if (acciones.getElemento().getHelburucas() != null) {
					UtilSQL.createFilterLikeSQL(where, params, "t2.HELBURUCAS", acciones.getElemento().getHelburucas(),
							startsWith);
				}
			}
			if (acciones.getOrden() != null) {
				UtilSQL.createFilterLikeSQL(where, params, "t1.ORDEN", acciones.getOrden(), startsWith);
			}
			if (acciones.getNombreeus() != null) {
				UtilSQL.createFilterLikeSQL(where, params, "t1.NOMBRE", acciones.getNombreeus(), startsWith);
			}
			if (acciones.getNombrecas() != null) {
				UtilSQL.createFilterLikeSQL(where, params, "t1.NOMBRECAS", acciones.getNombrecas(), startsWith);
			}
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
}
